## amarok 3.2.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

project(Amarok)

###############

if(BUILD_WITH_QT6)
  message(STATUS "Trying to build Qt6 version")
  set(KF_MIN_VERSION "6.0.0")
  set(KF_MAJOR_VERSION "6")
  set(QT_MIN_VERSION "6.4.0")
  set(QT_MAJOR_VERSION "6")
else()
  message(STATUS "Building good old Qt5 version")
  set(KF_MIN_VERSION "5.108.0")
  set(KF_MAJOR_VERSION "5")
  set(QT_MIN_VERSION "5.15.0")
  set(QT_MAJOR_VERSION "5")
endif()
find_package(PkgConfig REQUIRED)
find_package(ECM ${KF_MIN_VERSION} REQUIRED CONFIG)
set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules ${CMAKE_MODULE_PATH} ${ECM_MODULE_PATH})

include(KDEInstallDirs)
include(KDECMakeSettings)
#include(KDEFrameworkCompilerSettings NO_POLICY_SCOPE)
include(KDECompilerSettings NO_POLICY_SCOPE)
include(FeatureSummary)
include(ECMInstallIcons)
include(ECMSetupVersion)
include(ECMAddTests)
include(ECMAddAppIcon)
include(ECMPoQmTools)
include(FindPkgConfig)
include(CMakePushCheckState)
include(GenerateExportHeader)

find_package(Qt${QT_MAJOR_VERSION} ${QT_MIN_VERSION} REQUIRED COMPONENTS Core DBus Gui QuickWidgets Qml Sql Svg Test Widgets Xml)

find_package(Qt${QT_MAJOR_VERSION}QuickControls2 ${QT_MIN_VERSION})
set_package_properties(Qt${QT_MAJOR_VERSION}QuickControls2 PROPERTIES TYPE RUNTIME PURPOSE "Needed by the player's context area")


if(BUILD_WITH_QT6)
  find_package(Qt${QT_MAJOR_VERSION}Core5Compat ${QT_MIN_VERSION} REQUIRED)
  find_package(Qt${QT_MAJOR_VERSION}SvgWidgets ${QT_MIN_VERSION} REQUIRED)
  find_package(Qt${QT_MAJOR_VERSION}WebEngineWidgets ${QT_MIN_VERSION})
  set_package_properties(Qt${QT_MAJOR_VERSION}WebEngineWidgets PROPERTIES TYPE OPTIONAL PURPOSE "Needed by the wikipedia applet")
else()
  find_package(Qt${QT_MAJOR_VERSION}WebEngine ${QT_MIN_VERSION})
  set_package_properties(Qt${QT_MAJOR_VERSION}WebEngine PROPERTIES TYPE OPTIONAL PURPOSE "Needed by the wikipedia applet")
endif()

find_package(Qt${QT_MAJOR_VERSION}UiTools ${QT_MIN_VERSION})
set_package_properties(Qt${QT_MAJOR_VERSION}UiTools PROPERTIES TYPE OPTIONAL PURPOSE "Needed by the scripting engine")

find_package(KF${KF_MAJOR_VERSION} ${KF_MIN_VERSION} REQUIRED COMPONENTS
    Archive
    Codecs
    Config
    ConfigWidgets
    CoreAddons
    Crash
    DBusAddons
    DNSSD
    DocTools
    GlobalAccel
    GuiAddons
    I18n
    IconThemes
    KCMUtils
    KIO
    Notifications
    Package
    Solid
    TextEditor
    TextWidgets
    ThreadWeaver
    WidgetsAddons
    WindowSystem
)

if(BUILD_WITH_QT6)
  find_package(KF${KF_MAJOR_VERSION}ColorScheme ${KF_MIN_VERSION} REQUIRED)
  find_package(KF${KF_MAJOR_VERSION}KCMUtils ${KF_MIN_VERSION} REQUIRED)
  find_package(KF${KF_MAJOR_VERSION}StatusNotifierItem ${KF_MIN_VERSION} REQUIRED)
  find_package(KF${KF_MAJOR_VERSION}Kirigami ${KF_MIN_VERSION})
  set_package_properties(KF${KF_MAJOR_VERSION}Kirigami PROPERTIES TYPE RUNTIME PURPOSE "Needed by the player's context area")
else()
  find_package(KF${KF_MAJOR_VERSION}Kirigami2 ${KF_MIN_VERSION})
  set_package_properties(KF${KF_MAJOR_VERSION}Kirigami2 PROPERTIES TYPE RUNTIME PURPOSE "Needed by the player's context area")
endif()


###############
if(UNIX AND NOT APPLE AND NOT ANDROID AND NOT HAIKU)
  option(WITH_X11 "Build with X11 integration" ON)
endif()
option(WITH_UTILITIES "Enable building of utilities" ON)
option(WITH_PLAYER "Enable building of main Amarok player" ON)
# option(WITH_MP3Tunes "Enable mp3tunes in the Amarok player, requires multiple extra dependencies" ON) #build is disabled for now, no need to show option
option(WITH_GPODDER "Enable gpodder.net support" ON)
option(WITH_IPOD "Enable iPod support in Amarok" ON)
option(WITH_LASTFM "Enable last.fm support" ON)

############### Taglib
set(TAGLIB_MIN_VERSION "1.12")
find_package(Taglib REQUIRED)
set_package_properties( Taglib PROPERTIES DESCRIPTION "Support for Audio metadata." URL "https://taglib.org/" TYPE REQUIRED PURPOSE "Required for tag reading" )

# Check if TagLib is built with ASF and MP4 support
include(CheckCXXSourceCompiles)
cmake_push_check_state()
set(CMAKE_REQUIRED_INCLUDES "${TAGLIB_INCLUDES}")
set(CMAKE_REQUIRED_LIBRARIES "${TAGLIB_LIBRARIES}")

check_cxx_source_compiles("#include <asftag.h>
int main() { TagLib::ASF::Tag tag; return 0;}" TAGLIB_ASF_FOUND)
if( NOT TAGLIB_ASF_FOUND )
    message(FATAL_ERROR "TagLib does not have ASF support compiled in.")
endif()

check_cxx_source_compiles("#include <mp4tag.h>
int main() { TagLib::MP4::Tag tag(0, 0); return 0;}" TAGLIB_MP4_FOUND)
if( NOT TAGLIB_MP4_FOUND )
    message(FATAL_ERROR "TagLib does not have MP4 support compiled in.")
endif()

check_cxx_source_compiles("#include <modtag.h>
#include <modfile.h>
#include <s3mfile.h>
#include <itfile.h>
#include <xmfile.h>
using namespace TagLib;
int main() { char *s; Mod::Tag tag; Mod::File modfile(s); S3M::File s3mfile(s);
IT::File itfile(s); XM::File xmfile(s); return 0; }" TAGLIB_MOD_FOUND)

check_cxx_source_compiles("#include <opusfile.h>
int main() { char *s; TagLib::Ogg::Opus::File opusfile(s); return 0;}" TAGLIB_OPUS_FOUND)
cmake_pop_check_state()

set(TAGLIB-EXTRAS_MIN_VERSION "1.0")
find_package(Taglib-Extras)
set_package_properties(Taglib-Extras PROPERTIES DESCRIPTION "Support for metadata reading of RealMedia and Audible file types" URL "https://websvn.kde.org/trunk/kdesupport/taglib-extras/" TYPE OPTIONAL )
set(TAGLIB_EXTRAS_FOUND ${TAGLIB-EXTRAS_FOUND}) # we need a c-compatible name for the include file

include(CheckTagLibFileName)

check_taglib_filename(COMPLEX_TAGLIB_FILENAME)
###############


#Needed to conditionally build tests and gui
find_package(Googlemock)
set_package_properties( GOOGLEMOCK PROPERTIES DESCRIPTION "Used in Amarok's tests." URL "https://github.com/google/googlemock" TYPE OPTIONAL )

if(NOT GOOGLEMOCK_FOUND)
    set(BUILD_TESTING OFF)
endif()

if(BUILD_TESTING)
   add_definitions(-DDEBUG)
endif()

if(WITH_DESKTOP_UI)
    add_definitions(-DDESKTOP_UI)
endif()
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fmessage-length=0")
if (CMAKE_COMPILER_IS_GNUCXX)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fmessage-length=0")
    if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wl,--as-needed")
    endif()
endif ()

include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}/shared
    ${CMAKE_CURRENT_BINARY_DIR}/shared
)

set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

# WORKAROUND for Clang bug: http://llvm.org/bugs/show_bug.cgi?id=15651
if (CMAKE_CXX_COMPILER_ID STREQUAL "Clang" AND WIN32)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-delayed-template-parsing")
endif ()

####################################################################################
# CMAKE_AUTOMOC

if(NOT CMAKE_VERSION VERSION_LESS "3.10.0")
    # CMake 3.9+ warns about automoc on files without Q_OBJECT, and doesn't know about other macros.
    # 3.10+ lets us provide more macro names that require automoc.
    list(APPEND CMAKE_AUTOMOC_MACRO_NAMES AMAROK_EXPORT_SIMPLE_IMPORTER_PLUGIN)
endif()

add_definitions(-DQT_NO_URL_CAST_FROM_STRING -DQT_NO_CAST_TO_ASCII)

find_package(Phonon4Qt${QT_MAJOR_VERSION} 4.6.60 REQUIRED NO_MODULE)
add_definitions(-DPHONON_LIB_SONAME=\"${PHONON_LIB_SONAME}\")

if( WITH_LASTFM )
    find_package( LibLastFm )
    set( LIBLASTFM_MIN_VERSION "1.0.0" )
    if( LIBLASTFM_FOUND )
        if ( ${LIBLASTFM_MIN_VERSION} VERSION_LESS ${LIBLASTFM_VERSION} )
            set( LIBLASTFM_FOUND TRUE )
        endif()
    endif()
endif()

string( TOLOWER "${CMAKE_BUILD_TYPE}" CMAKE_BUILD_TYPE_TOLOWER )
if( CMAKE_BUILD_TYPE_TOLOWER MATCHES debug )
    set( DEBUG_BUILD_TYPE ON )
    if (MSVC)
        add_compile_options(/W4 /WX)
    else()
        add_definitions(-Wall -Wextra)
    endif()
endif()

add_subdirectory( data )
add_subdirectory( images )

if( WITH_PLAYER )
    find_package(Threads REQUIRED)

    find_package(MySQL)

    if( NOT MySQL_FOUND )
        find_package(MariaDB REQUIRED)
    endif()

    find_package(MySQLe)
    if( MySQLe_FOUND )
        set( BUILD_MYSQLE_COLLECTION TRUE )
        # zlib is required for mysql embedded
        find_package(ZLIB REQUIRED)
        set_package_properties( ZLIB PROPERTIES DESCRIPTION "zlib" TYPE REQUIRED )
    else()
        add_definitions( "-DNO_MYSQL_EMBEDDED" )
    endif()

    # We tell users that we need 1.0.3, but we really check just >= 1.0.0. This is because
    # upstream forgot to update version in lastfm/global.h, so it looks like 1.0.2. :-(
    # will be fixed in liblastfm-1.0.4
    set( LIBLASTFM_MIN_VERSION "1.0.3" )
    set_package_properties( LibLastFm PROPERTIES DESCRIPTION "Enable Last.Fm service, including scrobbling, song submissions, and suggested song dynamic playlists" URL "http://cdn.last.fm/client/liblastfm-${LIBLASTFM_MIN_VERSION}.tar.gz" TYPE OPTIONAL )

    find_package(FFmpeg)
    set_package_properties(FFmpeg PROPERTIES
        DESCRIPTION "Libraries and tools for handling multimedia data"
        URL "https://www.ffmpeg.org/"
        TYPE OPTIONAL
        PURPOSE "Enable MusicDNS service"
    )

    find_package(LibOFA)
    set_package_properties(LibOFA PROPERTIES
        DESCRIPTION "Open-source audio fingerprint by MusicIP"
        URL "http://code.google.com/p/musicip-libofa/"
        TYPE OPTIONAL
        PURPOSE "Enable MusicDNS service"
    )

    if( WITH_GPODDER )
        ## gpodder Service
        if(BUILD_WITH_QT6)
            find_package(Mygpo-qt6 1.1.0 CONFIG)
            set_package_properties(Mygpo-qt6 PROPERTIES
                DESCRIPTION "A Qt/C++ library wrapping the gpodder.net Webservice."
                URL "http://wiki.gpodder.org/wiki/Libmygpo-qt"
                TYPE OPTIONAL
                PURPOSE "Synchronize podcast subscriptions with gpodder.net"
            )
        else()
            find_package(Mygpo-qt5 1.1.0 CONFIG)
            set_package_properties(Mygpo-qt5 PROPERTIES
                DESCRIPTION "A Qt/C++ library wrapping the gpodder.net Webservice."
                URL "http://wiki.gpodder.org/wiki/Libmygpo-qt"
                TYPE OPTIONAL
                PURPOSE "Synchronize podcast subscriptions with gpodder.net"
            )
        endif()
    endif()

    if( WITH_GPODDER OR WITH_LASTFM ) ## problems in their header files as of 07/2024, not compatible with strict flags
        remove_definitions(
            -DQT_NO_CAST_FROM_ASCII
            -DQT_NO_KEYWORDS
        )
    endif()

    if( WITH_IPOD )
        find_package(Ipod)
        set(IPOD_MIN_VERSION "0.8.2")
        if( IPOD_FOUND AND NOT WIN32 )
            if ( ${IPOD_MIN_VERSION} VERSION_LESS ${IPOD_VERSION} )
                set( IPOD_FOUND TRUE )
            endif()
        endif()
        set_package_properties( Ipod PROPERTIES DESCRIPTION "Support Apple iPod/iPad/iPhone audio devices" URL "http://sourceforge.net/projects/gtkpod/" TYPE OPTIONAL )
        find_package(GDKPixBuf)
        set_package_properties( GDKPixBuf PROPERTIES DESCRIPTION "Support for artwork on iPod audio devices via GDK-PixBuf" URL "http://developer.gnome.org/arch/imaging/gdkpixbuf.html" TYPE OPTIONAL )
    endif()

    find_package(Mtp 1.0.0)
    set_package_properties(Mtp PROPERTIES
        TYPE OPTIONAL
        PURPOSE "Enable Support for portable media devices that use the media transfer protocol"
    )

    if( WITH_MP3Tunes )
        find_package(CURL)
        set_package_properties( CURL PROPERTIES DESCRIPTION "Used to transfer data with URLs" URL "https://curl.haxx.se/" TYPE OPTIONAL )

        find_package(LibXml2)
        set_package_properties( LibXml2 PROPERTIES DESCRIPTION "LibXML2 is an XML parser required by mp3tunes." URL "http://www.xmlsoft.org" TYPE OPTIONAL )

        find_package(OpenSSL)
        find_package(Libgcrypt)
        if ( OPENSSL_FOUND OR LIBGCRYPT_FOUND )
            set (_mp3tunes_crypto TRUE )
        else ()
            message( SEND_ERROR "Building with mp3tunes support REQUIRES either OpenSSL or GNU Libgcrypt" )
        endif ()

=== data/CMakeLists.txt ===
install( FILES amarok_homerc DESTINATION ${KDE_INSTALL_CONFDIR} )
if(BUILD_WITH_QT6)
  install( FILES amarok.notifyrc DESTINATION ${KDE_INSTALL_KNOTIFYRCDIR} )
else()
  install( FILES amarok.notifyrc DESTINATION ${KDE_INSTALL_KNOTIFY5RCDIR} )
endif()

install(FILES DefaultPlaylistLayouts.xml
              first_run_jingle.ogg
              DESTINATION ${KDE_INSTALL_DATADIR}/amarok/data)

=== doc/CMakeLists.txt ===
kdoctools_create_handbook(index.docbook INSTALL_DESTINATION ${KDE_INSTALL_DOCBUNDLEDIR}/en SUBDIR amarok)

=== shared/CMakeLists.txt ===
set( amarokshared_SRCS
    FileType.cpp
    FileTypeResolver.cpp
    MetaReplayGain.cpp
    MetaTagLib.cpp
    TagsFromFileNameGuesser.cpp
)

set( amarokshared_collectionscanner_SRCS
    collectionscanner/Album.cpp
    collectionscanner/BatchFile.cpp
    collectionscanner/Directory.cpp
    collectionscanner/Playlist.cpp
    collectionscanner/ScanningState.cpp
    collectionscanner/Track.cpp
)


set( amarokshared_tag_helpers_SRCS
    tag_helpers/APETagHelper.cpp
    tag_helpers/ASFTagHelper.cpp
    tag_helpers/ID3v2TagHelper.cpp
    tag_helpers/MP4TagHelper.cpp
    tag_helpers/StringHelper.cpp
    tag_helpers/TagHelper.cpp
    tag_helpers/VorbisCommentTagHelper.cpp
)

add_library( amarokshared SHARED
    ${amarokshared_SRCS}
    ${amarokshared_collectionscanner_SRCS}
    ${amarokshared_tag_helpers_SRCS} )

generate_export_header(amarokshared BASE_NAME amarokshared)


target_include_directories( amarokshared PUBLIC ${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR} )

include_directories(SYSTEM ${TAGLIB_INCLUDES} )
add_definitions( ${TAGLIB_CFLAGS} )
target_link_libraries( amarokshared ${TAGLIB_LIBRARIES} KF${KF_MAJOR_VERSION}::Codecs)
if( TAGLIB-EXTRAS_FOUND )
    include_directories(SYSTEM ${TAGLIB-EXTRAS_INCLUDES} )
    add_definitions( ${TAGLIB-EXTRAS_CFLAGS} )
    target_link_libraries( amarokshared ${TAGLIB-EXTRAS_LIBRARIES} )
endif()

if(BUILD_WITH_QT6)
  target_link_libraries( amarokshared
    Qt::Core
    Qt::Gui # for QImage, ...
    Qt::Core5Compat
  )
else()
  target_link_libraries( amarokshared
    Qt::Core
    Qt::Gui # for QImage, ...
  )
endif()


set_target_properties( amarokshared PROPERTIES VERSION 1.0.0 SOVERSION 1 )
install( TARGETS amarokshared ${KDE_INSTALL_TARGETS_DEFAULT_ARGS} )

=== src/CMakeLists.txt ===
# Improves speed of string concatenation
add_definitions(-DQT_USE_FAST_CONCATENATION)
add_definitions(-DQT_USE_FAST_OPERATOR_PLUS)

if(APPLE)
    set(mac_SRCS
        app_mac.cpp
        mac/GrowlInterface.cpp
    )
    # Notification Center Appeared in 10.8, or Darwin 12
    if( CMAKE_SYSTEM_VERSION VERSION_GREATER "11.9.9")
        list(APPEND mac_SRCS mac/MacSystemNotify.mm)
        add_definitions(-DHAVE_NOTIFICATION_CENTER)
    endif()

    include_directories ( services/lastfm/ )
    set( MAC_FILES_DIR  ${CMAKE_SOURCE_DIR}/src/mac )
endif()

include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}/core-impl/collections/db/sql/
)

add_subdirectory( core )
add_subdirectory( core-impl/collections )
add_subdirectory( core-impl/storage/sql )
add_subdirectory( context )
add_subdirectory( services )
add_subdirectory( scripting/scripts )
add_subdirectory( transcoding )
add_subdirectory( importers )

#####################################################################
# PROXYCOLLECTION
#####################################################################
set(aggregatecollection_SRCS
    core-impl/collections/aggregate/AggregateCollection.cpp
    core-impl/collections/aggregate/AggregateMeta.cpp
    core-impl/collections/aggregate/AggregateQueryMaker.cpp
)

#####################################################################
# MEDIADEVICEFRAMEWORK
#####################################################################
set(libmediadeviceframework_SRCS
  core-impl/collections/mediadevicecollection/MediaDeviceCollection.cpp
  core-impl/collections/mediadevicecollection/MediaDeviceCollectionLocation.cpp
  core-impl/collections/mediadevicecollection/MediaDeviceMeta.cpp
  core-impl/collections/mediadevicecollection/MediaDeviceTrackEditor.cpp
  core-impl/collections/mediadevicecollection/handler/MediaDeviceHandler.cpp
  core-impl/collections/mediadevicecollection/handler/MediaDeviceHandlerCapability.cpp
  core-impl/collections/mediadevicecollection/handler/capabilities/ArtworkCapability.cpp
  core-impl/collections/mediadevicecollection/handler/capabilities/PlaylistCapability.cpp
  core-impl/collections/mediadevicecollection/handler/capabilities/PodcastCapability.cpp
  core-impl/collections/mediadevicecollection/handler/capabilities/ReadCapability.cpp
  core-impl/collections/mediadevicecollection/handler/capabilities/WriteCapability.cpp
  core-impl/collections/mediadevicecollection/playlist/MediaDevicePlaylist.cpp
  core-impl/collections/mediadevicecollection/playlist/MediaDeviceUserPlaylistProvider.cpp
  core-impl/collections/mediadevicecollection/podcast/MediaDevicePodcastProvider.cpp
  core-impl/collections/mediadevicecollection/support/ConnectionAssistant.cpp
  core-impl/collections/mediadevicecollection/support/MediaDeviceInfo.cpp
)

#####################################################################
# SERVICEFRAMEWORK
#####################################################################
set(libserviceframework_SRCS
    services/DynamicServiceQueryMaker.cpp
    services/InfoParserBase.cpp
    services/ServiceAlbumCoverDownloader.cpp
    services/ServiceBase.cpp
    services/ServiceCapabilities.cpp
    services/ServiceCollection.cpp
    services/ServiceCollectionLocation.cpp
    services/ServiceCollectionTreeView.cpp
    services/ServiceMetaBase.cpp
    services/ServicePluginManager.cpp
    services/ServiceSqlCollection.cpp
    services/ServiceSqlQueryMaker.cpp
    services/ServiceSqlRegistry.cpp
)

#####################################################################
# SERVICEBROWSER
#####################################################################
set(libservicebrowser_SRCS
    browsers/servicebrowser/ServiceBrowser.cpp
)

#####################################################################
# AMAROKURL
#####################################################################
set(libamarokurl_SRCS
    amarokurls/AmarokUrl.cpp
    amarokurls/AmarokUrlAction.cpp
    amarokurls/AmarokUrlHandler.cpp
    amarokurls/BookmarkCurrentButton.cpp
    amarokurls/ContextUrlGenerator.cpp
    amarokurls/ContextUrlRunner.cpp
    amarokurls/NavigationUrlRunner.cpp
    amarokurls/NavigationUrlGenerator.cpp
    amarokurls/PlayUrlRunner.cpp
    amarokurls/PlayUrlGenerator.cpp
    amarokurls/BookmarkManager.cpp
    amarokurls/BookmarkManagerWidget.cpp
    amarokurls/BookmarkGroup.cpp
    amarokurls/BookmarkModel.cpp
    amarokurls/BookmarkTreeView.cpp
    amarokurls/BookmarkMetaActions.cpp
    )

#####################################################################
# SCRIPTABLESERVICE
#####################################################################
set(libscriptableservice_SRCS
    services/scriptable/ScriptableService.cpp
    services/scriptable/ScriptableServiceCollection.cpp
    services/scriptable/ScriptableServiceCollectionTreeModel.cpp
    services/scriptable/ScriptableServiceInfoParser.cpp
    services/scriptable/ScriptableServiceManager.cpp
    services/scriptable/ScriptableServiceMeta.cpp
    services/scriptable/ScriptableServiceQueryMaker.cpp
)

#####################################################################
# CONFIGDIALOG
#####################################################################
set(libconfigdialog_SRCS
    configdialog/ConfigDialog.cpp
    configdialog/ConfigDialogBase.cpp
    configdialog/dialogs/CollectionConfig.cpp
    configdialog/dialogs/ExcludedLabelsDialog.cpp
    configdialog/dialogs/GeneralConfig.cpp
    configdialog/dialogs/MetadataConfig.cpp
    configdialog/dialogs/NotificationsConfig.cpp
    configdialog/dialogs/PlaybackConfig.cpp
    configdialog/dialogs/PluginsConfig.cpp
    configdialog/dialogs/ScriptsConfig.cpp
    configdialog/dialogs/ScriptSelector.cpp
    configdialog/dialogs/DatabaseConfig.cpp
)

ki18n_wrap_ui(libconfigdialog_SRCS
    configdialog/dialogs/CollectionConfig.ui
    configdialog/dialogs/GeneralConfig.ui
    configdialog/dialogs/MetadataConfig.ui
    configdialog/dialogs/ExcludedLabelsDialog.ui
    configdialog/dialogs/NotificationsConfig.ui
    configdialog/dialogs/PlaybackConfig.ui
    configdialog/dialogs/DatabaseConfig.ui
    configdialog/dialogs/ScriptsConfig.ui
)

set(libbrowserframework_SRCS
    browsers/BrowserBreadcrumbItem.cpp
    browsers/BrowserBreadcrumbWidget.cpp
    browsers/BrowserCategory.cpp
    browsers/BrowserCategoryList.cpp
    browsers/BrowserCategoryListModel.cpp
    browsers/BrowserCategoryListSortFilterProxyModel.cpp
    browsers/BrowserDock.cpp
    browsers/BrowserMessageArea.cpp
    browsers/CollectionSortFilterProxyModel.cpp
    browsers/CollectionTreeItem.cpp
    browsers/CollectionTreeItemModel.cpp
    browsers/CollectionTreeItemModelBase.cpp
    browsers/CollectionTreeView.cpp
    browsers/InfoProxy.cpp
    browsers/SingleCollectionTreeItemModel.cpp
)

#####################################################################
# COLLECTIONBROWSER
#####################################################################
set(libcollectionbrowser_SRCS
    browsers/collectionbrowser/CollectionBrowserTreeView.cpp
    browsers/collectionbrowser/CollectionWidget.cpp
)

#####################################################################
# SYNCHRONIZATION
#####################################################################
set(libsynchronization_SRCS
    synchronization/MasterSlaveSynchronizationJob.cpp
    synchronization/OneWaySynchronizationJob.cpp
    synchronization/SynchronizationBaseJob.cpp
    synchronization/UnionJob.cpp
)

#####################################################################
# STATUSBAR
#####################################################################
set(libstatusbar_SRCS
    statusbar/ProgressBar.cpp
    statusbar/KJobProgressBar.cpp
    statusbar/NetworkProgressBar.cpp
    statusbar/CompoundProgressBar.cpp
    statusbar/PopupWidget.cpp
    statusbar/LongMessageWidget.cpp
)


#####################################################################
# META
#####################################################################
set(libmetaimpl_SRCS
    core-impl/playlists/providers/user/UserPlaylistProvider.cpp
    core-impl/playlists/types/file/asx/ASXPlaylist.cpp
    core-impl/playlists/types/file/m3u/M3UPlaylist.cpp
    core-impl/playlists/types/file/pls/PLSPlaylist.cpp
    core-impl/playlists/types/file/PlaylistFileLoaderJob.cpp
    core-impl/playlists/types/file/PlaylistFileSupport.cpp
    core-impl/playlists/types/file/xspf/XSPFPlaylist.cpp
    core-impl/capabilities/AlbumActionsCapability.cpp
    core-impl/capabilities/timecode/TimecodeBoundedPlaybackCapability.cpp
    core-impl/capabilities/timecode/TimecodeLoadCapability.cpp
    core-impl/capabilities/timecode/TimecodeWriteCapability.cpp
    core-impl/capabilities/multisource/MultiSourceCapabilityImpl.cpp
    core-impl/meta/file/File.cpp
    core-impl/meta/file/FileTrackProvider.cpp
    core-impl/meta/multi/MultiTrack.cpp
    core-impl/meta/cue/CueFileSupport.cpp
    core-impl/meta/proxy/MetaProxy.cpp
    core-impl/meta/proxy/MetaProxyWorker.cpp
    core-impl/meta/stream/Stream.cpp
    core-impl/playlists/types/file/PlaylistFile.cpp
    core-impl/support/PersistentStatisticsStore.cpp
    core-impl/support/TagStatisticsStore.cpp
    core-impl/support/UrlStatisticsStore.cpp
)

#####################################################################
# COLLECTION
#####################################################################
set(collection_SRCS
    core-impl/collections/support/jobs/WriteTagsJob.cpp
    core-impl/collections/support/ArtistHelper.cpp
    core-impl/collections/support/CollectionManager.cpp
    core-impl/collections/support/CollectionLocationDelegateImpl.cpp
    core-impl/collections/support/MemoryCustomValue.cpp
    core-impl/collections/support/MemoryFilter.cpp
    core-impl/collections/support/MemoryMatcher.cpp
    core-impl/collections/support/MemoryMeta.cpp
    core-impl/collections/support/MemoryQueryMaker.cpp
    core-impl/collections/support/MemoryQueryMakerInternal.cpp
    core-impl/collections/support/MemoryQueryMakerHelper.cpp
    core-impl/collections/support/TrashCollectionLocation.cpp
    core-impl/collections/support/XmlQueryReader.cpp
    core-impl/collections/support/FileCollectionLocation.cpp
    core-impl/collections/support/Expression.cpp
    core-impl/collections/support/TextualQueryFilter.cpp
)

#####################################################################
# STORAGE
#####################################################################
set(storage_SRCS
    core-impl/storage/StorageManager.cpp
)

#####################################################################
# SCANNER
#####################################################################
set( scanner_SRCS
    scanner/GenericScanManager.cpp
    scanner/GenericScannerJob.cpp
    scanner/AbstractDirectoryWatcher.cpp
    scanner/AbstractScanResultProcessor.cpp
)

#####################################################################
# CONTEXT
#####################################################################
set( libcontextview_SRCS
    context/AmarokContextPackageStructure.cpp
    context/AppletLoader.cpp
    context/AppletModel.cpp
    context/ContextDock.cpp
    context/ContextView.cpp
)

#####################################################################
# LYRICS
#####################################################################
set( liblyrics_SRCS
    lyrics/LyricsManager.cpp
)

#####################################################################
# PODCASTS
#####################################################################
set(libpodcasts_SRCS
    core-impl/podcasts/sql/SqlPodcastMeta.cpp
    core-impl/podcasts/sql/SqlPodcastProvider.cpp
    core-impl/podcasts/sql/PodcastSettingsDialog.cpp
    core-impl/podcasts/sql/PodcastFilenameLayoutConfigDialog.cpp
)

#####################################################################
# PLAYLISTBROWSER
#####################################################################
set(libplaylistbrowser_SRCS

=== tests/CMakeLists.txt ===
set( EXECUTABLE_OUTPUT_PATH ${CMAKE_CURRENT_BINARY_DIR} )

set( AMAROK_SOURCE_TREE ${CMAKE_SOURCE_DIR}/src )
set( AMAROK_TEST_TREE ${CMAKE_SOURCE_DIR}/tests )
set( AMAROK_UTILITY_TREE ${CMAKE_SOURCE_DIR}/utilities )
set( AMAROK_UTILITIES_DIR ${CMAKE_BINARY_DIR}/bin )
set( STRESS_TEST_TRACK_COUNT 20000 )

configure_file(config-amarok-test.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config-amarok-test.h )

include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}
    ${CMAKE_SOURCE_DIR}/src
    ${CMAKE_BINARY_DIR}/src
)
include_directories(SYSTEM
    ${GOOGLEMOCK_INCLUDE_DIR} )

if( LIBLASTFM_FOUND ) # needed by Last.fm error handler in App.cpp
    include_directories(SYSTEM ${LIBLASTFM_INCLUDE_DIR})
endif()

add_subdirectory( amarokurls )
add_subdirectory( browsers )
add_subdirectory( context )
add_subdirectory( core )
add_subdirectory( core-impl )
add_subdirectory( dynamic )
if( ${CMAKE_SYSTEM_NAME} MATCHES "Linux" )
add_subdirectory( importers )
endif()
add_subdirectory( playlist )
add_subdirectory( playlistmanager )
add_subdirectory( timecode )
add_subdirectory( scanner )
add_subdirectory( synchronization )

#------------------------ Test Amarok namespace -----------------------------

set( testamarok_SRCS
        TestAmarok.cpp
        ${AMAROK_SOURCE_TREE}/core/support/Amarok.cpp
    )

add_executable( testamarok ${testamarok_SRCS} )
add_test(NAME testamarok COMMAND $<TARGET_FILE:testamarok>)
ecm_mark_as_test(testamarok)

target_link_libraries( testamarok
    KF${KF_MAJOR_VERSION}::KIOCore
    Qt::Test
    amarokcore
    amaroklib
    )

#------------------------ Test Debug -----------------------------

add_definitions(-DDEBUG_OVERRIDE_ELAPSED_TIME=4.9)
set( testdebug_SRCS
     TestDebug.cpp
     ${AMAROK_SOURCE_TREE}/core/support/Debug.cpp
     )

add_executable( testdebug ${testdebug_SRCS} )
add_test(NAME testdebug COMMAND $<TARGET_FILE:testdebug>)
ecm_mark_as_test(testdebug)
target_link_libraries(testdebug Qt::Test amarokcore )

#------------------------ Test EngineController -----------------------------

set( testenginecontroller_SRCS TestEngineController.cpp )
add_executable( testenginecontroller ${testenginecontroller_SRCS} )
add_test(NAME testenginecontroller COMMAND $<TARGET_FILE:testenginecontroller>)
ecm_mark_as_test(testenginecontroller)
target_link_libraries( testenginecontroller KF${KF_MAJOR_VERSION}::ThreadWeaver Qt::Test amaroklib amarokcore )

#------------------------ Test Expression -----------------------------

set( testexpression_SRCS
        TestExpression.cpp
        ${AMAROK_SOURCE_TREE}/core-impl/collections/support/Expression.cpp
    )

add_executable( testexpression  ${testexpression_SRCS} )
add_test(NAME testexpression COMMAND $<TARGET_FILE:testexpression>)
ecm_mark_as_test(testexpression)

target_link_libraries(testexpression Qt::Test)

#------------------------ Test QStringx -----------------------------

set( testqstringx_SRCS
        TestQStringx.cpp
        ${AMAROK_SOURCE_TREE}/QStringx.cpp
    )

add_executable( testqstringx  ${testqstringx_SRCS} )
add_test(NAME testqstringx COMMAND $<TARGET_FILE:testqstringx>)
ecm_mark_as_test(testqstringx)

target_link_libraries(testqstringx Qt::Test)

#------------------------ Test TagGuesser -----------------------------

set( testtagguesser_SRCS
        TestTagGuesser.cpp
        ${CMAKE_SOURCE_DIR}/shared/TagsFromFileNameGuesser.cpp
        ${AMAROK_SOURCE_TREE}/dialogs/TagGuesser.cpp
    )

add_executable( testtagguesser  ${testtagguesser_SRCS} )
add_test(NAME testtagguesser COMMAND $<TARGET_FILE:testtagguesser>)
ecm_mark_as_test(testtagguesser)

target_link_libraries(testtagguesser Qt::Test amarokcore)

#------------------------ Test TrackOrganizer -----------------------------

set( testtrackorganizer_SRCS
        TestTrackOrganizer.cpp
        ${AMAROK_SOURCE_TREE}/dialogs/TrackOrganizer.cpp
        ${AMAROK_SOURCE_TREE}/core/meta/Meta.cpp
        ${AMAROK_SOURCE_TREE}/QStringx.cpp
        ${GOOGLEMOCK_SRCS}
    )

add_executable( testtrackorganizer  ${testtrackorganizer_SRCS} )
add_test(NAME testtrackorganizer COMMAND $<TARGET_FILE:testtrackorganizer>)
ecm_mark_as_test(testtrackorganizer)

# Since Google recommends not to distribute a pre-compiled gtest library
# we have to build it our own
if(GOOGLEMOCK_GTEST_SOURCES)
    add_subdirectory( ${GOOGLEMOCK_GTEST_SOURCES} gtest )
    add_dependencies( testtrackorganizer gtest )
endif()

add_dependencies( testtrackorganizer amarokcore )
add_dependencies( testtrackorganizer amaroklib )

target_link_libraries( testtrackorganizer amarokcore amaroklib KF${KF_MAJOR_VERSION}::Solid Qt::Test Qt::Core Qt::Gui ${GOOGLEMOCK_LIBRARIES})

=== images/icons/CMakeLists.txt ===
########### install files ###############

ecm_install_icons(ICONS
    128-status-audio-volume-high-amarok.png
    128-status-audio-volume-low-amarok.png
    128-status-audio-volume-medium-amarok.png
    128-status-audio-volume-muted-amarok.png
    16-actions-amarok_artist.png
    16-actions-amarok_cart_add.png
    16-actions-amarok_cart_remove.png
    16-actions-amarok_cart_view.png
    16-actions-amarok_change_language.png
    16-actions-amarok_clock.png
    16-actions-amarok_lyrics.png
    16-actions-amarok_playcount.png
    16-actions-amarok_playlist.png
    16-actions-amarok_playlist_refresh.png
    16-actions-amarok_scripts.png
    16-actions-amarok_track.png
    16-actions-collection-rescan-amarok.png
    16-actions-download-amarok.png
    16-actions-dynamic-amarok.png
    16-actions-favorite-genres-amarok.png
    16-actions-filename-album-amarok.png
    16-actions-filename-artist-amarok.png
    16-actions-filename-bpm-amarok.png
    16-actions-filename-comment-amarok.png
    16-actions-filename-composer-amarok.png
    16-actions-filename-dash-amarok.png
    16-actions-filename-discnumber-amarok.png
    16-actions-filename-dot-amarok.png
    16-actions-filename-filetype-amarok.png
    16-actions-filename-genre-amarok.png
    16-actions-filename-ignore-amarok.png
    16-actions-filename-initial-amarok.png
    16-actions-filename-last-played.png
    16-actions-filename-slash-amarok.png
    16-actions-filename-space-amarok.png
    16-actions-filename-title-amarok.png
    16-actions-filename-track-amarok.png
    16-actions-filename-underscore-amarok.png
    16-actions-filename-year-amarok.png
    16-actions-label-amarok.png
    16-actions-lastfm-mix-radio-amarok.png
    16-actions-lastfm-neighbour-radio-amarok.png
    16-actions-lastfm-personal-radio-amarok.png
    16-actions-lastfm-recommended-radio-amarok.png
    16-actions-lastfm-tag-amarok.png
    16-actions-love-amarok.png
    16-actions-media-album-cover-manager-amarok.png
    16-actions-media-album-repeat-amarok.png
    16-actions-media-playlist-repeat-amarok.png
    16-actions-media-random-albums-amarok.png
    16-actions-media-random-tracks-amarok.png
    16-actions-media-repeat-album-amarok.png
    16-actions-media-repeat-playlist-amarok.png
    16-actions-media-repeat-track-amarok.png
    16-actions-media-show-active-track-amarok.png
    16-actions-media-standard-track-progression-amarok.png
    16-actions-media-track-add-amarok.png
    16-actions-media-track-edit-amarok.png
    16-actions-media-track-queue-amarok.png
    16-actions-media-track-remove-amarok.png
    16-actions-music-amarok.png
    16-actions-playlist-generator.png
    16-actions-podcast-amarok.png
    16-actions-preferences-indicator-amarok.png
    16-actions-preferences-media-playback-amarok.png
    16-actions-preferences-multimedia-player-amarok.png
    16-actions-preferences-view-amarok.png
    16-actions-remove-amarok.png
    16-actions-view-importers-banshee-amarok.png
    16-actions-view-importers-clementine-amarok.png
    16-actions-view-importers-rhythmbox-amarok.png
    16-actions-view-services-amazon-amarok.png
    16-actions-view-services-ampache-amarok.png
    16-actions-view-services-gpodder-amarok.png
    16-actions-view-services-jamendo-amarok.png
    16-actions-view-services-lastfm-amarok.png
    16-actions-view-services-librivox-amarok.png
    16-actions-view-services-magnatune-amarok.png
    16-actions-view-services-mp3tunes-amarok.png
    16-actions-view-services-opml-amarok.png
    16-actions-view-services-scripted-amarok.png
    22-actions-amarok_artist.png
    22-actions-amarok_cart_add.png
    22-actions-amarok_cart_remove.png
    22-actions-amarok_cart_view.png
    22-actions-amarok_change_language.png
    22-actions-amarok_clock.png
    22-actions-amarok_lyrics.png
    22-actions-amarok_playcount.png
    22-actions-amarok_playlist.png
    22-actions-amarok_playlist_refresh.png
    22-actions-amarok_scripts.png
    22-actions-amarok_track.png
    22-actions-collection-rescan-amarok.png
    22-actions-download-amarok.png
    22-actions-dynamic-amarok.png
    22-actions-filename-bpm-amarok.png
    22-actions-internet-amarok.png
    22-actions-love-amarok.png
    22-actions-media-album-cover-manager-amarok.png
    22-actions-media-album-repeat-amarok.png
    22-actions-media-playlist-repeat-amarok.png
    22-actions-media-random-albums-amarok.png
    22-actions-media-random-tracks-amarok.png
    22-actions-media-repeat-album-amarok.png
    22-actions-media-repeat-playlist-amarok.png
    22-actions-media-repeat-track-amarok.png
    22-actions-media-show-active-track-amarok.png
    22-actions-media-standard-track-progression-amarok.png
    22-actions-media-track-add-amarok.png
    22-actions-media-track-edit-amarok.png
    22-actions-media-track-queue-amarok.png
    22-actions-media-track-remove-amarok.png
    22-actions-music-amarok.png
    22-actions-playlist-generator.png
    22-actions-podcast-amarok.png
    22-actions-preferences-indicator-amarok.png
    22-actions-preferences-media-playback-amarok.png
    22-actions-preferences-multimedia-player-amarok.png
    22-actions-preferences-view-amarok.png
    22-actions-remove-amarok.png
    22-actions-view-importers-banshee-amarok.png
    22-actions-view-importers-clementine-amarok.png
    22-actions-view-importers-rhythmbox-amarok.png
    22-actions-view-services-amazon-amarok.png
    22-actions-view-services-gpodder-amarok.png
    22-actions-view-services-jamendo-amarok.png
    22-actions-view-services-lastfm-amarok.png
    22-actions-view-services-librivox-amarok.png
    22-actions-view-services-magnatune-amarok.png
    22-actions-view-services-mp3tunes-amarok.png
    22-actions-view-services-opml-amarok.png
    22-actions-view-services-scripted-amarok.png
    24-actions-lastfm-my-friends-amarok.png
    24-actions-lastfm-my-neighbours-amarok.png
    24-actions-lastfm-my-tags-amarok.png
    32-actions-amarok_artist.png
    32-actions-amarok_cart_add.png
    32-actions-amarok_cart_remove.png
    32-actions-amarok_cart_view.png
    32-actions-amarok_change_language.png
    32-actions-amarok_clock.png
    32-actions-amarok_lyrics.png
    32-actions-amarok_playcount.png
    32-actions-amarok_playlist.png
    32-actions-amarok_playlist_refresh.png
    32-actions-amarok_scripts.png
    32-actions-amarok_track.png
    32-actions-audioscrobbler.png
    32-actions-collection-rescan-amarok.png
    32-actions-download-amarok.png
    32-actions-dynamic-amarok.png
    32-actions-filename-bpm-amarok.png
    32-actions-love-amarok.png
    32-actions-media-album-cover-manager-amarok.png
    32-actions-media-album-cover.png
    32-actions-media-album-repeat-amarok.png
    32-actions-media-album-track.png
    32-actions-media-playlist-repeat-amarok.png
    32-actions-media-random-albums-amarok.png
    32-actions-media-random-tracks-amarok.png
    32-actions-media-repeat-album-amarok.png
    32-actions-media-repeat-playlist-amarok.png
    32-actions-media-repeat-track-amarok.png
    32-actions-media-show-active-track-amarok.png
    32-actions-media-standard-track-progression-amarok.png
    32-actions-media-track-add-amarok.png
    32-actions-media-track-edit-amarok.png
    32-actions-media-track-queue-amarok.png
    32-actions-media-track-remove-amarok.png
    32-actions-music-amarok.png
    32-actions-playlist-generator.png
    32-actions-podcast-amarok.png
    32-actions-preferences-indicator-amarok.png
    32-actions-preferences-media-playback-amarok.png
    32-actions-preferences-multimedia-player-amarok.png
    32-actions-preferences-view-amarok.png
    32-actions-remove-amarok.png
    32-actions-view-importers-banshee-amarok.png
    32-actions-view-importers-clementine-amarok.png
    32-actions-view-importers-rhythmbox-amarok.png
    32-actions-view-services-amazon-amarok.png
    32-actions-view-services-ampache-amarok.png
    32-actions-view-services-gpodder-amarok.png
    32-actions-view-services-jamendo-amarok.png
    32-actions-view-services-lastfm-amarok.png
    32-actions-view-services-magnatune-amarok.png
    32-actions-view-services-mp3tunes-amarok.png
    32-actions-view-services-opml-amarok.png
    32-actions-view-services-scripted-amarok.png
    48-actions-amarok_artist.png
    48-actions-amarok_cart_add.png
    48-actions-amarok_cart_remove.png
    48-actions-amarok_cart_view.png
    48-actions-amarok_change_language.png
    48-actions-amarok_clock.png
    48-actions-amarok_playcount.png
    48-actions-amarok_playlist.png
    48-actions-amarok_playlist_refresh.png
    48-actions-amarok_scripts.png
    48-actions-amarok_track.png
    48-actions-collection-rescan-amarok.png
    48-actions-download-amarok.png
    48-actions-dynamic-amarok.png
    48-actions-filename-album-amarok.png
    48-actions-filename-and-amarok.png
    48-actions-filename-artist-amarok.png
    48-actions-filename-bpm-amarok.png
    48-actions-filename-comment-amarok.png
    48-actions-filename-composer-amarok.png
    48-actions-filename-dash-amarok.png
    48-actions-filename-discnumber-amarok.png
    48-actions-filename-divider.png
    48-actions-filename-dot-amarok.png
    48-actions-filename-filetype-amarok.png
    48-actions-filename-genre-amarok.png
    48-actions-filename-group-length.png
    48-actions-filename-group-tracks.png
    48-actions-filename-ignore-amarok.png
    48-actions-filename-initial-amarok.png
    48-actions-filename-last-played.png
    48-actions-filename-moodbar.png
    48-actions-filename-sample-rate.png
    48-actions-filename-slash-amarok.png
    48-actions-filename-space-amarok.png
    48-actions-filename-title-amarok.png
    48-actions-filename-track-amarok.png
    48-actions-filename-underscore-amarok.png
    48-actions-filename-year-amarok.png
    48-actions-info-amarok.png
    48-actions-label-amarok.png
    48-actions-love-amarok.png
    48-actions-media-album-repeat-amarok.png
    48-actions-media-playlist-repeat-amarok.png
    48-actions-media-random-albums-amarok.png
    48-actions-media-random-tracks-amarok.png
    48-actions-media-repeat-album-amarok.png
    48-actions-media-repeat-playlist-amarok.png
    48-actions-media-repeat-track-amarok.png
    48-actions-media-show-active-track-amarok.png
    48-actions-media-standard-track-progression-amarok.png
    48-actions-media-track-add-amarok.png
    48-actions-media-track-edit-amarok.png
    48-actions-media-track-queue-amarok.png
    48-actions-media-track-remove-amarok.png
    48-actions-music-amarok.png
    48-actions-playlist-generator.png
    48-actions-podcast-amarok.png
    48-actions-preferences-indicator-amarok.png
    48-actions-preferences-media-playback-amarok.png
    48-actions-preferences-multimedia-player-amarok.png
    48-actions-preferences-view-amarok.png
    48-actions-remove-amarok.png
    48-actions-similarartists-amarok.png
    48-actions-upcomingevents-amarok.png
    48-actions-videoclip-amarok.png
    48-actions-view-importers-banshee-amarok.png
    48-actions-view-importers-clementine-amarok.png
    48-actions-view-importers-rhythmbox-amarok.png
    48-actions-view-services-amazon-amarok.png
    48-actions-view-services-ampache-amarok.png
    48-actions-view-services-gpodder-amarok.png
    48-actions-view-services-jamendo-amarok.png
    48-actions-view-services-lastfm-amarok.png
    48-actions-view-services-magnatune-amarok.png
    48-actions-view-services-mp3tunes-amarok.png
    DESTINATION ${KDE_INSTALL_DATADIR}/amarok/icons
    THEME hicolor
)

=== src/context/CMakeLists.txt ===
add_subdirectory( applets )


########### next target ###############

set( amarokpud_LIB_SRCS
    popupdropper/libpud/PopupDropper.cpp
    popupdropper/libpud/PopupDropperItem.cpp
    popupdropper/libpud/PopupDropperView.cpp
)

add_library( amarokpud SHARED ${amarokpud_LIB_SRCS} )

if(WIN32)
    target_compile_definitions(amarokpud PRIVATE MAKE_POPUPDROPPER_LIB)
endif()

target_include_directories( amarokpud PUBLIC
    ${CMAKE_CURRENT_SOURCE_DIR}/popupdropper/libpud
)

if(BUILD_WITH_QT6)
  target_link_libraries(amarokpud Qt::Core Qt::Gui Qt::Svg Qt::SvgWidgets Qt::Widgets)
else()
  target_link_libraries(amarokpud Qt::Core Qt::Gui Qt::Svg Qt::Widgets)
endif()

install( TARGETS amarokpud ${KDE_INSTALL_TARGETS_DEFAULT_ARGS} )


set(qml_plugin_qml_files
    qml_plugin/qmldir
    qml_plugin/Applet.qml
    qml_plugin/AppletHeader.qml
)

set(qml_plugin_SRCS
    qml_plugin/src/RatingItem.cpp
    qml_plugin/src/Plugin.cpp
    qml_plugin/src/PixmapItem.cpp
)

add_library(qml_plugin SHARED ${qml_plugin_SRCS})

if(BUILD_WITH_QT6)
    target_link_libraries(qml_plugin
        amarokcore
        Qt::Quick
        KF${KF_MAJOR_VERSION}::WidgetsAddons
    )
else()
    target_link_libraries(qml_plugin
        amarokcore
        Qt::Quick
        KF${KF_MAJOR_VERSION}::WidgetsAddons
    )
endif()

install( TARGETS qml_plugin DESTINATION ${KDE_INSTALL_QMLDIR}/org/kde/amarok/qml )

install( FILES ${qml_plugin_qml_files} DESTINATION ${KDE_INSTALL_QMLDIR}/org/kde/amarok/qml )

kpackage_install_package( context_qml_package org.kde.amarok.context genericqml )

=== src/importers/CMakeLists.txt ===
add_subdirectory( amarok )
add_subdirectory( banshee )
add_subdirectory( clementine )
add_subdirectory( fastforward )
add_subdirectory( itunes )
add_subdirectory( rhythmbox )

=== tests/amarokurls/CMakeLists.txt ===
include_directories(
        ${AMAROK_TEST_TREE}
        ${CMAKE_BINARY_DIR}/tests
        )

set( testamarokurls_SRCS TestAmarokUrls.cpp )
add_executable( testamarokurls ${testamarokurls_SRCS} )
add_test(NAME testamarokurls COMMAND $<TARGET_FILE:testamarokurls>)
ecm_mark_as_test(testamarokurls)
target_link_libraries( testamarokurls amarokcore amaroklib Qt::Test )

=== tests/dynamic/CMakeLists.txt ===
macro(link_database_test test_target)
    if(APPLE)
        set_target_properties(${test_target} PROPERTIES LINK_FLAGS "-undefined dynamic_lookup")
    endif()

    add_dependencies( ${test_target} amarokconfig_h )
    add_dependencies( ${test_target} amarokcore )
    add_dependencies( ${test_target} amaroklib)

    target_link_libraries(${test_target}
        amarokcore
        amaroklib
        KF${KF_MAJOR_VERSION}::KIOCore
        KF${KF_MAJOR_VERSION}::ThreadWeaver
        Qt::Test
        Qt::Core
        ${MYSQL_LIBRARIES}
        ${CMAKE_DL_LIBS}
#        ${TAGLIB-EXTRAS_LIBRARIES}
#        ${TAGLIB_LIBRARIES}
    )

endmacro(link_database_test)


include_directories(
  ${AMAROK_TEST_TREE}
  ${AMAROK_SOURCE_TREE}
  # ${AMAROK_SOURCE_TREE}/core-impl/logger
  ${AMAROK_UTILITY_TREE}
  ${CMAKE_BINARY_DIR}/src
  ${CMAKE_BINARY_DIR}/tests
  ${AMAROK_COLLECTION_SUPPORT_DIR}
)

include_directories(SYSTEM
  ${MYSQL_INCLUDE_DIR}
  )

#------------------------------- DynamicModel Test -------------------------------

set( dynamicmodel_SRCS
        TestDynamicModel.cpp
    )

add_executable( testdynamicmodel ${dynamicmodel_SRCS} )
add_test(NAME testdynamicmodel COMMAND $<TARGET_FILE:testdynamicmodel>)
ecm_mark_as_test(testdynamicmodel)
link_database_test( testdynamicmodel )

#------------------------------- TrackSet Test -------------------------------

set( trackset_SRCS
        TestTrackSet.cpp
    )

add_executable( testtrackset ${trackset_SRCS} )
add_test(NAME testtrackset COMMAND $<TARGET_FILE:testtrackset>)
ecm_mark_as_test(testtrackset)
link_database_test( testtrackset )

=== tests/importers/CMakeLists.txt ===
add_custom_target( importers_files
    ${CMAKE_COMMAND} -E copy_directory "${AMAROK_TEST_TREE}/importers/files" "${CMAKE_BINARY_DIR}/tests/importers_files"
    VERBATIM
)

set( testimporterscommon_LIBS
    amaroklib
    amarokcore
    KF${KF_MAJOR_VERSION}::KIOCore
    KF${KF_MAJOR_VERSION}::ThreadWeaver
    Qt::Sql
    Qt::Test
    ${GOOGLEMOCK_LIBRARIES}
)

#------------------------ Test ImporterManager ----------------------------

set( testimportermanager_SRCS
    TestImporterManager.cpp
    ImporterMocks.cpp
    ${GOOGLEMOCK_SRCS}
)

add_executable( testimportermanager ${testimportermanager_SRCS} )
add_test(NAME testimportermanager COMMAND $<TARGET_FILE:testimportermanager>)
ecm_mark_as_test(testimportermanager)
target_link_libraries( testimportermanager ${testimporterscommon_LIBS} )

#------------------------ Test ImporterProvider ---------------------------

set( testimporterprovider_SRCS
    TestImporterProvider.cpp
    ImporterMocks.cpp
    ${GOOGLEMOCK_SRCS}
)

add_executable( testimporterprovider ${testimporterprovider_SRCS} )
add_test(NAME testimporterprovider COMMAND $<TARGET_FILE:testimporterprovider>)
ecm_mark_as_test(testimporterprovider)
target_link_libraries( testimporterprovider ${testimporterscommon_LIBS} )

#------------------------ Test SimpleImporterConfigWidget -----------------

set( testsimpleimporterconfigwidget_SRCS TestSimpleImporterConfigWidget.cpp )
add_executable( testsimpleimporterconfigwidget ${testsimpleimporterconfigwidget_SRCS} )
add_test(NAME testsimpleimporterconfigwidget COMMAND $<TARGET_FILE:testsimpleimporterconfigwidget>)
ecm_mark_as_test(testsimpleimporterconfigwidget)
target_link_libraries( testsimpleimporterconfigwidget ${testimporterscommon_LIBS} )

#------------------------ Test AmarokImporter -----------------------------

set( testamarokimporter_SRCS
    TestImporterBase.cpp
    TestAmarokImporter.cpp
    ${AMAROK_SOURCE_TREE}/importers/amarok/AmarokConfigWidget.cpp
    ${AMAROK_SOURCE_TREE}/importers/amarok/AmarokManager.cpp
    ${AMAROK_SOURCE_TREE}/importers/amarok/AmarokProvider.cpp
    ${AMAROK_SOURCE_TREE}/importers/amarok/AmarokEmbeddedSqlConnection.cpp
    ${AMAROK_SOURCE_TREE}/importers/amarok/AmarokTrack.cpp
)
ki18n_wrap_ui( testamarokimporter_SRCS
    ${AMAROK_SOURCE_TREE}/importers/amarok/AmarokConfigWidget.ui
)

add_executable( testamarokimporter ${testamarokimporter_SRCS} )
add_test(NAME testamarokimporter COMMAND $<TARGET_FILE:testamarokimporter>)
ecm_mark_as_test(testamarokimporter)
add_dependencies( testamarokimporter importers_files )
target_link_libraries( testamarokimporter
    amarok_importer-amarok
    ${testimporterscommon_LIBS}
)

#------------------------ Test BansheeImporter -------------------------------

set( testbansheeimporter_SRCS
    TestImporterBase.cpp
    TestBansheeImporter.cpp
    ${AMAROK_SOURCE_TREE}/importers/banshee/BansheeConfigWidget.cpp
    ${AMAROK_SOURCE_TREE}/importers/banshee/BansheeManager.cpp
    ${AMAROK_SOURCE_TREE}/importers/banshee/BansheeProvider.cpp
    ${AMAROK_SOURCE_TREE}/importers/banshee/BansheeTrack.cpp
)

add_executable( testbansheeimporter ${testbansheeimporter_SRCS} )
add_test(NAME testbansheeimporter COMMAND $<TARGET_FILE:testbansheeimporter>)
ecm_mark_as_test(testbansheeimporter)
add_dependencies( testbansheeimporter importers_files )
target_link_libraries( testbansheeimporter
    amarok_importer-banshee
    ${testimporterscommon_LIBS}
)

#------------------------ Test ClementineImporter ----------------------------

set( testclementineimporter_SRCS
    TestImporterBase.cpp
    TestClementineImporter.cpp
    ${AMAROK_SOURCE_TREE}/importers/clementine/ClementineConfigWidget.cpp
    ${AMAROK_SOURCE_TREE}/importers/clementine/ClementineManager.cpp
    ${AMAROK_SOURCE_TREE}/importers/clementine/ClementineProvider.cpp
    ${AMAROK_SOURCE_TREE}/importers/clementine/ClementineTrack.cpp
)

add_executable( testclementineimporter ${testclementineimporter_SRCS} )
add_test(NAME testclementineimporter COMMAND $<TARGET_FILE:testclementineimporter>)
ecm_mark_as_test(testclementineimporter)
add_dependencies( testclementineimporter importers_files )
target_link_libraries( testclementineimporter
    amarok_importer-clementine
    ${testimporterscommon_LIBS}
)

#------------------------ Test FastForwardImporter ------------------------

set( testfastforwardimporter_SRCS
    TestImporterBase.cpp
    TestFastForwardImporter.cpp
    ${AMAROK_SOURCE_TREE}/importers/fastforward/FastForwardConfigWidget.cpp
    ${AMAROK_SOURCE_TREE}/importers/fastforward/FastForwardManager.cpp
    ${AMAROK_SOURCE_TREE}/importers/fastforward/FastForwardProvider.cpp
    ${AMAROK_SOURCE_TREE}/importers/fastforward/FastForwardTrack.cpp
)
ki18n_wrap_ui( testfastforwardimporter_SRCS
    ${AMAROK_SOURCE_TREE}/importers/fastforward/FastForwardConfigWidget.ui
)

add_executable( testfastforwardimporter ${testfastforwardimporter_SRCS} )
add_test(NAME testfastforwardimporter COMMAND $<TARGET_FILE:testfastforwardimporter>)
ecm_mark_as_test(testfastforwardimporter)
add_dependencies( testfastforwardimporter importers_files )
target_link_libraries( testfastforwardimporter
    amarok_importer-fastforward
    ${testimporterscommon_LIBS}
)

#------------------------ Test ITunesImporter -----------------------------

set( testitunesimporter_SRCS
    TestImporterBase.cpp
    TestITunesImporter.cpp
    ${AMAROK_SOURCE_TREE}/importers/itunes/ITunesConfigWidget.cpp
    ${AMAROK_SOURCE_TREE}/importers/itunes/ITunesManager.cpp
    ${AMAROK_SOURCE_TREE}/importers/itunes/ITunesProvider.cpp
    ${AMAROK_SOURCE_TREE}/importers/itunes/ITunesTrack.cpp
)

add_executable( testitunesimporter ${testitunesimporter_SRCS} )
add_test(NAME testitunesimporter COMMAND $<TARGET_FILE:testitunesimporter>)
ecm_mark_as_test(testitunesimporter)
add_dependencies( testitunesimporter importers_files )
target_link_libraries( testitunesimporter
    amarok_importer-itunes
    ${testimporterscommon_LIBS}
)

#------------------------ Test RhythmboxImporter -----------------------------

set( testrhytmboximporter_SRCS
    TestImporterBase.cpp
    TestRhythmboxImporter.cpp
    ${AMAROK_SOURCE_TREE}/importers/rhythmbox/RhythmboxConfigWidget.cpp
    ${AMAROK_SOURCE_TREE}/importers/rhythmbox/RhythmboxManager.cpp
    ${AMAROK_SOURCE_TREE}/importers/rhythmbox/RhythmboxProvider.cpp
    ${AMAROK_SOURCE_TREE}/importers/rhythmbox/RhythmboxTrack.cpp
)

add_executable( testrhytmboximporter ${testrhytmboximporter_SRCS} )
add_test(NAME testrhytmboximporter COMMAND $<TARGET_FILE:testrhytmboximporter>)
ecm_mark_as_test(testrhytmboximporter)
add_dependencies( testrhytmboximporter importers_files )
target_link_libraries( testrhytmboximporter
    amarok_importer-rhythmbox
    ${testimporterscommon_LIBS}
)

=== debian/changelog ===
amarok (2:3.2.2-1ubuntu2) questing; urgency=medium

  * No-change rebuild against Qt 5.15.17.

 -- Dmitry Shachnev <mitya57@ubuntu.com>  Tue, 15 Jul 2025 13:03:31 +0300

amarok (2:3.2.2-1ubuntu1) plucky; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    2: epoch.

 -- Rik Mills <rikmills@kde.org>  Mon, 17 Feb 2025 13:15:53 +0000

amarok (3.2.2-1) unstable; urgency=medium

  * New upstream release.

 -- Pino Toscano <pino@debian.org>  Sun, 16 Feb 2025 13:03:46 +0100

=== debian/control ===
Source: amarok
Section: sound
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
Uploaders: Pino Toscano <pino@debian.org>,
Build-Depends: debhelper-compat (= 13),
 dh-exec,
 dh-sequence-kf5,
 cmake (>= 3.16~),
 gettext,
 pkgconf,
 python3:any,
 libtag-dev (>= 1.12~),
 qtbase5-dev (>= 5.15.0~),
 qttools5-dev (>= 5.15.0~),
 qtdeclarative5-dev (>= 5.15.0~),
 libqt5svg5-dev (>= 5.15.0~),
 qtquickcontrols2-5-dev (>= 5.15.0~),
 qtwebengine5-dev (>= 5.15.0~) [amd64 arm64 armhf i386],
 libphonon4qt5-dev,
 libphonon4qt5experimental-dev,
 extra-cmake-modules (>= 5.108.0~),
 libkf5archive-dev (>= 5.108.0~),
 libkf5codecs-dev (>= 5.108.0~),
 libkf5config-dev (>= 5.108.0~),
 libkf5configwidgets-dev (>= 5.108.0~),
 libkf5coreaddons-dev (>= 5.108.0~),
 libkf5crash-dev (>= 5.108.0~),
 libkf5dbusaddons-dev (>= 5.108.0~),
 libkf5dnssd-dev (>= 5.108.0~),
 libkf5doctools-dev (>= 5.108.0~),
 libkf5globalaccel-dev (>= 5.108.0~),
 libkf5guiaddons-dev (>= 5.108.0~),
 libkf5i18n-dev (>= 5.108.0~),
 libkf5iconthemes-dev (>= 5.108.0~),
 libkf5kcmutils-dev (>= 5.108.0~),
 libkf5kio-dev (>= 5.108.0~),
 libkf5notifications-dev (>= 5.108.0~),
 libkf5package-dev (>= 5.108.0~),
 libkf5solid-dev (>= 5.108.0~),
 libkf5texteditor-dev (>= 5.108.0~),
 libkf5textwidgets-dev (>= 5.108.0~),
 libkf5threadweaver-dev (>= 5.108.0~),
 libkf5wallet-dev (>= 5.108.0~),
 libkf5widgetsaddons-dev (>= 5.108.0~),
 libkf5windowsystem-dev (>= 5.108.0~),
 kirigami2-dev,
 libmtp-dev (>= 1.0.0),
 libglib2.0-dev, libgpod-dev (>= 0.7.0),
 libmariadbd-dev, libmariadb-dev,
 libqca-qt5-2-dev, liblastfm5-dev (>= 1.0.3),
 libavformat-dev (>= 4:0.5), libofa0-dev,
 libmygpo-qt-dev,
 libgdk-pixbuf-2.0-dev,
Build-Depends-Indep: mariadb-server-core
Standards-Version: 4.7.0
Rules-Requires-Root: no
Homepage: https://amarok.kde.org
Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/amarok.git
Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/amarok

Package: amarok
Architecture: any
Depends: amarok-common (= ${source:Version}), amarok-utils (= ${binary:Version}),
 qml-module-org-kde-kirigami2 (>= 5.15.0~),
 qml-module-qtqml-models2 (>= 5.15.0~),
 qml-module-qtquick-controls2 (>= 5.15.0~),
 qml-module-qtquick-dialogs (>= 5.15.0~),
 qml-module-qtquick-layouts (>= 5.15.0~),
 qml-module-qtquick2 (>= 5.15.0~),
 qml-module-qtwebengine (>= 5.15.0~) [amd64 arm64 armhf i386],
 ${shlibs:Depends}, ${misc:Depends},
Recommends: kio-audiocd,
Suggests: amarok-doc (>= ${source:Version}), libqt5sql5-sqlite, libqt5sql5-mysql, libqt5sql5-psql,
 moodbar
Description: easy to use media player based on the KDE Platform
 Amarok is a powerful music player with an intuitive interface. It makes
 playing the music you love and discovering new music easier than ever before
 and it looks good doing it! Amarok is based on the powerful Qt4 / KDE4
 Platform and nicely integrates with KDE desktop.
 .
 Much work has been invested into integrating Amarok 2 with various Web
 services:
   - Ampache
   - Jamendo Service
   - Last.fm
   - Librivox
   - MP3tunes
   - Magnatune
   - OPML Podcast Directory
 .
 Amarok comes with a lot of features including but not limited to:
   - Scripts - enhance your Amarok experience with community developed scripts.
   - Dynamic Playlists - create playlists that automatically update.
   - Context View - customize interface with the Plasma powered Context View.
   - PopUp Dropper - simplify drag&drop actions with revolutionary menu system.
   - Multiple Language Translations
   - Collection Management - organizing your music collection has never been
     easier with Amarok's powerful tagging, renaming, and sorting abilities.
   - Database Importing - import collections from Amarok 1.4 or iTunes.
   - Scriptable Services - integrate other web services into Amarok.

Package: amarok-common
Architecture: all
Depends: ${misc:Depends},
Recommends: amarok (>= ${source:Version})
Description: architecture independent files for Amarok
 This package contains architecture independent files needed for Amarok to run
 properly. Therefore, unless you have 'amarok' package of the same version
 installed, you will hardly find this package useful.
 .
 Amarok is a powerful music player with an intuitive interface.

Package: amarok-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Recommends: amarok (>= ${source:Version}), khelpcenter
Description: Amarok documentation (Handbook)
 This package contains Amarok user documentation in various languages. It can be
 opened from the application menu Help -> Amarok Handbook.
 .
 Amarok is a powerful music player with an intuitive interface.

Package: amarok-utils
Section: utils
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: utilities for Amarok media player
 This package contains command line utilities that are typically used by Amarok
 media player but might also be useful on systems without Amarok installed.
 They are designed to be lightweight as they do not depend on KDE libraries.
 .
 Currently the package contains the following utilities:
   - amarokcollectionscanner - scans audio files, collects information from
     file tags and prints it in the structured XML format.
   - amarok_afttagger - a helper program which writes/removes custom tags
     to/from media files required for embedded "Amarok File Tracking".

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

override_dh_auto_configure:
	dh_auto_configure -Skf5 -- -DBUILD_TESTING=false

override_dh_bugfiles:
	dh_bugfiles -A

execute_after_dh_install-indep:
	# Copy errmsg.sys files from mariadb-server-core package
	debian/copy-errmsg-files.py /usr/share/mariadb debian/amarok-common/usr/share/amarok/mysqle

execute_after_dh_auto_install:
	# Remove development stuff
	find debian/tmp -name '*.so' -type l -print -delete

%:
	dh $@

.PHONY: override_dh_auto_test

=== debian/watch ===
version=4
https://download.kde.org/stable/amarok/([\d.]+)/amarok-([\d.]+)\.tar\.xz
